package {
	import away3d.containers.ObjectContainer3D;
	import away3d.entities.Mesh;
	import away3d.events.AssetEvent;
	import away3d.events.LoaderEvent;
	import away3d.library.assets.AssetType;
	import away3d.loaders.AssetLoader;
	import away3d.loaders.Loader3D;
	import away3d.loaders.misc.AssetLoaderContext;
	import away3d.loaders.parsers.Max3DSParser;
	import away3d.loaders.parsers.OBJParser;
	
	import deng.fzip.*;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.net.URLLoaderDataFormat;
	import flash.display.LoaderInfo;
	
	/**
	 *  Loader3d   @loth
	 *  .3DS .OBJ .ZIP
	 * ( fzip need adler32 checksums : use phyton scripe from FZIP in assets  )
	 *  setting in Object = { name:String, file:String, size:Number, endFunction:Function  }
	 *  return    endFunction ( ObjectContainer3D )
	 */
	public class Import{ 
		private var _engine           :Object;
		private var _tmp              :Object;
		private var _id               :int;
		
		public function Import(Engine:Object):void{
			_engine = Engine;
			_tmp = new Object();
		}
		
		//_______________________________________________________
		//     import model function
		//_______________________________________________________
		public function obj3D(n:Object):void{
			_engine.outtext.htmlText+="init loading" 
			if(n.file != ""){
				switch(n.file.substring(n.file.length-3))
				{
					case "3DS": case "3ds": bin(n.file, on3DSLoad, n); break;
					case "OBJ": case "obj": bin(n.file, onOBJLoad, n); break;
					case "ZIP": case "zip": zip(n.file, onFZIPLoad, n); break;
				}
			}
		}
		
		//_______________________________________________________
		//      model complete
		//_______________________________________________________
		private function onResourceComplete(e:LoaderEvent):void
		{
			e.target.removeEventListener(LoaderEvent.RESOURCE_COMPLETE, onResourceComplete);
			//e.target.removeEventListener(AssetEvent.ASSET_COMPLETE, onAssetComplete);
			
			// final reference ObjectContainer3D
			var name:String = e.target.name;
			var content:ObjectContainer3D = ObjectContainer3D(e.target);    //Loader3D( e.target );
			// add or hide container to scene
			//if( _tmp[name].hide==null)_engine.addObject(content);
			
			// return object in function
			if( _tmp[name].endFunction != null)  _tmp[name].endFunction( content );
			
			// delete tmp reference
			_tmp[e.target.name]=null;
		}
		
		//_______________________________________________________
		//    zip
		//_______________________________________________________
		private function onFZIPLoad(fzip:FZip, n:Object):void
		{
			var name:String;
			for( var i:uint=0; i<fzip.getFileCount(); i++){
				name = fzip.getFileAt(i).filename;
				switch(name.substring(name.length-3)){
					case "3DS": case "3ds": on3DSLoad(fzip.getFileAt(i).content as ByteArray, n); break;
					case "OBJ": case "obj": onOBJLoad(fzip.getFileAt(i).content as ByteArray, n); break;
				}
			}
		}
		
		//_______________________________________________________
		//    obj
		//_______________________________________________________	
		private function onOBJLoad(MeshData:ByteArray, n:Object):void
		{
			var assetLoaderContext:AssetLoaderContext = new AssetLoaderContext(false);
			var parser:OBJParser = new OBJParser()
			var loader:Loader3D = new Loader3D();
			loader.name = n.name;
			_tmp[n.name] = n;
			loader.scale(n.size);
			loader.addEventListener(LoaderEvent.RESOURCE_COMPLETE, onResourceComplete);
			//loader.addEventListener(AssetEvent.ASSET_COMPLETE, onAssetComplete);
			loader.loadData(MeshData, assetLoaderContext, null, parser);
		}
		
		//_______________________________________________________
		//    3ds
		//_______________________________________________________	
		private function on3DSLoad(MeshData:ByteArray, n:Object):void
		{
			var assetLoaderContext:AssetLoaderContext = new AssetLoaderContext(false);
			var parser:Max3DSParser = new Max3DSParser()
			var loader:Loader3D = new Loader3D();
			loader.name = n.name;
			_tmp[n.name] = n;
			loader.scale(n.size);
			loader.addEventListener(LoaderEvent.RESOURCE_COMPLETE, onResourceComplete);
			//loader.addEventListener(AssetEvent.ASSET_COMPLETE, onAssetComplete);
			loader.loadData(MeshData, assetLoaderContext, null, parser);
		}
		
		/*private function onAssetLoadFailed(event:AssetEvent):void
		{
			//	_engine.tell("! error detected")
		}
		
		private function onAssetComplete(e:AssetEvent):void
		{
			//var n:Object = _tmp[e.target.name];
			if (e.asset.assetType == AssetType.MESH) // test mesh
			if (e.asset.assetType == AssetType.MATERIAL)// test material
		}*/


		//_______________________________________________________
		//   Binary loading 
		//_______________________________________________________
		public function bin( link:String, onFinich:Function=null, n:Object=null ):void
		{
			//_current = "bin"+"  "+link;
			//_tell("load: ", link, 1);
			var name:String = link;
			var ext:String = link.substring(link.length-3);
			// use id for unique load
			//if(_id!=0) link=link+"?uniq="+_id;
			var loader:URLLoader = new URLLoader();
			
			if(ext=="DAE")loader.dataFormat = URLLoaderDataFormat.TEXT;
			else loader.dataFormat = URLLoaderDataFormat.BINARY;
			
			loader.load(new URLRequest(link));
			loader.addEventListener(Event.COMPLETE, binLoaded);
			loader.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			loader.addEventListener(ProgressEvent.PROGRESS, loadProgress);
			loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
			function binLoaded(e:Event):void {
				// var loader:Loader=(e.target as LoaderInfo).loader;
				onFinich((e.target as URLLoader).data, n)
				loader.removeEventListener(Event.COMPLETE, binLoaded);
				loader.removeEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
				loader.removeEventListener(ProgressEvent.PROGRESS, loadProgress);
				loader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
				loader = null;
			}
		}
		
		//_______________________________________________________
		//   Fzip loading 
		//_______________________________________________________
		public function zip( link:String, onFinich:Function=null, n:Object=null):void
		{
			//_current = "zip"+"  "+link;
			var name:String = link;
			// use id for unique load
			//if(_id!=0) link=link+"?uniq="+_id;
			
			var loader:FZip= new FZip();
			//loader.addEventListener(Event.COMPLETE, onLoadZipComplete);
			loader.addEventListener(FZipEvent.FILE_LOADED, onLoadZipComplete);
			loader.addEventListener(ProgressEvent.PROGRESS, loadProgress);
			loader.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
			loader.addEventListener(FZipErrorEvent.PARSE_ERROR, parseErrorHandler);
			loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
			
			loader.load(new URLRequest(link));
			//try {  loader.load(new URLRequest(link));  }
			//catch (e:Error) { trace(e.message) }
			function onLoadZipComplete(e:Event):void{
				var loader:FZip = FZip(e.target)// as LoaderInfo).loader;
				
				onFinich(loader, n);
				//loader.removeEventListener(Event.COMPLETE, onLoadZipComplete);
				loader.addEventListener(FZipEvent.FILE_LOADED, onLoadZipComplete);
				loader.removeEventListener(ProgressEvent.PROGRESS, loadProgress);
				loader.removeEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
				loader.removeEventListener(FZipErrorEvent.PARSE_ERROR, parseErrorHandler);
				loader.removeEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
				
				loader = null;
			}
		}

		//_______________________________________________________
		//   loading progress
		//_______________________________________________________
		private function loadProgress(e:ProgressEvent):void
		{ 
			var P:int = int(e.bytesLoaded / e.bytesTotal * 100), ko:int =(e.bytesLoaded / 1024)<<0;
			_engine.outtext.htmlText = P 
			//if(P==100){ _select.width=0; _select.height=0; }
			//else {
			//	if(_select.height == 0) _select.height=2;
			//	_select.width=P;
			//}
		}
		
		//_______________________________________________________
		//    loading error
		//_______________________________________________________
		private function ioErrorHandler( e:IOErrorEvent ):void
		{
		//	_tell("File Error:", _current, 2);
		}
		private function securityErrorHandler( e:SecurityErrorEvent ):void
		{
		//	_tell("Security Error", "", 2);
		}
		private function parseErrorHandler( e:SecurityErrorEvent ):void
		{
		//	_tell("AssetLoader Zip Parse Error:" ,"", 2);
		}



	}
}